/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.configuracioneccomerciales.cyberviaje;

import com.rjconsultores.ventaboletos.entidad.ProdPuntoVenta;
import com.rjconsultores.ventaboletos.entidad.PuntoVenta;
import com.rjconsultores.ventaboletos.service.ProdPuntoVentaService;
import com.rjconsultores.ventaboletos.service.PuntoVentaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyComboboxPuntoVenta;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import java.util.Calendar;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;

/**
 *
 * @author Administrador
 */
@Controller("editarProdPuntoVentaController")
@Scope("prototype")
public class EditarProdPuntoVentaController extends MyGenericForwardComposer {

    @Autowired
    private ProdPuntoVentaService prodPuntoVentaService;
    @Autowired
    private PuntoVentaService puntoVentaService;
    private List<PuntoVenta> lsPuntoVentas;
    private MyListbox prodPuntoVentaList;
    private MyComboboxPuntoVenta cmbPuntoVenta;
    private ProdPuntoVenta prodPuntoVenta;
    private List<ProdPuntoVenta> lsProdPuntoVenta;
    private static Logger log = Logger.getLogger(EditarProdPuntoVentaController.class);

    public List<PuntoVenta> getLsPuntoVentas() {
        return lsPuntoVentas;
    }

    public void setLsPuntoVentas(List<PuntoVenta> lsPuntoVentas) {
        this.lsPuntoVentas = lsPuntoVentas;
    }

    public ProdPuntoVenta getProdPuntoVenta() {
        return prodPuntoVenta;
    }

    public void setProdPuntoVenta(ProdPuntoVenta prodPuntoVenta) {
        this.prodPuntoVenta = prodPuntoVenta;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        lsProdPuntoVenta = (List<ProdPuntoVenta>)Executions.getCurrent().getArg().get("lsProdPuntoVenta");
        prodPuntoVenta = (ProdPuntoVenta) Executions.getCurrent().getArg().get("prodPuntoVenta");
        prodPuntoVentaList = (MyListbox) Executions.getCurrent().getArg().get("prodPuntoVentaList");

        super.doAfterCompose(comp);
        if (prodPuntoVenta != null){
            cmbPuntoVenta.setInitialValue(prodPuntoVenta.getPuntoVenta());
        }
    }

    public void onClick$btnAdicionar(Event ev) throws Exception {

        cmbPuntoVenta.getValue();

        if (prodPuntoVenta.getPuntoVenta() == null) {
            Messagebox.show(
                    Labels.getLabel("MSG.Error.combobox"),
                    Labels.getLabel("editarProdPuntoVentaController.winEditarProdPuntoVenta.title"),
                    Messagebox.OK, Messagebox.ERROR);
            return;
        }

        if (prodPuntoVenta.getProdpuntoventaId() != null) {
            if (registroDuplicado()) {
                Messagebox.show(
                        Labels.getLabel("editarPricingController.MSG.categoriaExiste"),
                        Labels.getLabel("editarProdPuntoVentaController.winEditarProdPuntoVenta.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
                return;
            }
            prodPuntoVentaService.actualizacion(prodPuntoVenta);
            prodPuntoVentaList.updateItem(prodPuntoVenta);
            lsProdPuntoVenta.add(prodPuntoVenta);
        } else {
            if (registroDuplicado()) {
                Messagebox.show(
                        Labels.getLabel("editarPricingController.MSG.categoriaExiste"),
                        Labels.getLabel("editarProdPuntoVentaController.winEditarProdPuntoVenta.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
                return;
            }
            prodPuntoVentaService.suscribir(prodPuntoVenta);
            prodPuntoVentaList.addItem(prodPuntoVenta);
            lsProdPuntoVenta.add(prodPuntoVenta);
        }

        closeWindow();
    }

    private boolean registroDuplicado() throws InterruptedException {
        
        for (ProdPuntoVenta p : lsProdPuntoVenta) {
            if (!p.getActivo()){
                continue;
            }
            if (p.getPuntoVenta().getNombpuntoventa().equals(prodPuntoVenta.getPuntoVenta().getNombpuntoventa())) {
                return true;
            }
        }
        return false;
    }

    public void onClick$btnRemover(Event ev) {
        try {
            Integer resp = Messagebox.show(
                    Labels.getLabel("editarProdPuntoVentaController.MSG.borrarPergunta"),
                    Labels.getLabel("editarProdPuntoVentaController.winEditarProdPuntoVenta.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp.equals(Messagebox.YES)) {
                prodPuntoVenta.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                prodPuntoVenta.setFecmodif(Calendar.getInstance().getTime());
                prodPuntoVenta.setActivo(Boolean.FALSE);

                prodPuntoVentaList.removeItem(prodPuntoVenta);
                prodPuntoVentaService.borrar(prodPuntoVenta);

                Messagebox.show(
                        Labels.getLabel("editarProdPuntoVentaController.MSG.borrarSucesso"),
                        Labels.getLabel("editarProdPuntoVentaController.winEditarProdPuntoVenta.title"),
                        Messagebox.YES, Messagebox.EXCLAMATION);

                closeWindow();
            }

        } catch (Exception ex) {
            log.error(ex);
        }
    }

    /**
     * @return the lsProdPuntoVenta
     */
    public List<ProdPuntoVenta> getLsProdPuntoVenta() {
        return lsProdPuntoVenta;
    }

    /**
     * @param lsProdPuntoVenta the lsProdPuntoVenta to set
     */
    public void setLsProdPuntoVenta(List<ProdPuntoVenta> lsProdPuntoVenta) {
        this.lsProdPuntoVenta = lsProdPuntoVenta;
    }
}
